Message " Creating Slash Library... "
CREATELIB "Slash"
;
;  All rights reserved. (c) Copyright 1991.
;                       by: Steven Booth
;                           N28W29868 Oakwood Grove Road
;                           Pewaukee, WI 53072
;
;     BldSlash.a  - Build File Name with double slashes. Required for passed
;                   parameters for FXWRITE or WPWRITE.
;         GetYN.a - Get a Y/N Response
;     PaintCanv.u - Paint Canvas

PROC BldSlash.a(Str.a)
;
; ** BldSlash.a = Builds a file name with double slashes in it.
;

Private Save_Str.a,       ; Saved String
        Str_posl.s,       ; Slash
        Temp.a            ; Temporary Holding String

   Str_posl.s = SEARCH("\\", Str.a)
   IF ( Str_posl.s = 0 ) THEN
      Save_Str.a = Str.a
      RELEASE VARS Str.a
      Return Save_Str.a
   ELSE
      Temp.a = Str.a
      Save_Str.a = ""
      WHILE ( Str_posl.s <> 0 )
         Save_Str.a = Save_Str.a +
                            SUBSTR(Temp.a, 1, Str_posl.s ) + "\\"
         Temp.a = SUBSTR( Temp.a, Str_posl.s+1, (Len(Temp.a) - Str_posl.s) )
         Str_posl.s = SEARCH("\\", Temp.a)
      ENDWHILE
      Save_Str.a = Save_Str.a + Temp.a
      RELEASE VARS Str.a
      Return Save_Str.a
   ENDIF
ENDPROC

PROC FxWrite.u(Table_Name, File_Name)
;
;    FxWrite calls the FxWrite Program to write a table out to a Disk file.
;
;    Inputs:
;            Table_Name = Name of the Table to be written.
;             File_Name = Name of the Fixed Length Data File to be created.
;
;    Note: FxWrite writes two files... the file specified by "File_Name" and
;          the informational file "FIXFILE.DAT".

     Private CMD
     Array Tmp_Tables[17]

     Tmp_Tables[1] = "Answer"
     Tmp_Tables[2] = "Changed"
     Tmp_Tables[3] = "Crosstab"
     Tmp_Tables[4] = "Deleted"
     Tmp_Tables[5] = "Entry"
     Tmp_Tables[6] = "Entry1"
     Tmp_Tables[7] = "Entry2"
     Tmp_Tables[8] = "Family"
     Tmp_Tables[9] = "Inserted"
    Tmp_Tables[10] = "Keyviol"
    Tmp_Tables[11] = "Keyviol1"
    Tmp_Tables[12] = "Keyviol2"
    Tmp_Tables[13] = "List"
    Tmp_Tables[14] = "Password"
    Tmp_Tables[15] = "Problems"
    Tmp_Tables[16] = "Password"
    Tmp_Tables[17] = "Struct"

    Table_Found = "N"
    FOR I FROM 1 TO 17
        IF Tmp_Tables[I] = Table_Name THEN
           Table_Found = "Y"
           QUITLOOP
        ENDIF
    ENDFOR

    If Table_Found = "Y" Then
       Rename_Table = "Y"
       Rename "Answer" "Answer2"
       Table_Name2 = "Answer2"
    Else
       Rename_Table = "N"
       Table_Name2 = Table_Name
    Endif
    CMD = "RUN \"FXWRITE " + Table_Name2 + " " + File_Name + "\""
    EXECUTE CMD
    If Rename_Table = "Y" Then
       Rename "Answer2" "Answer"
       Table_Name = "Answer"
    Endif
ENDPROC

PROC GetYN.a(msg.a)

; Get Yes/No Answer
;
;     Returns:  Y, N, or ESC

Private Ans.a

WHILE CHARWAITING()           ; Eat any characters already in buffer
      Ans.a = GETCHAR()
ENDWHILE

PaintCanv.u(msg.a)
WHILE ( True )
   gc.a = GETCHAR()
   IF ( gc.a = 27 ) THEN
      retval = False
      ?? "Esc"
      QUITLOOP
   ENDIF
   Ans.a = UPPER(CHR(gc.a))
   IF ( Ans.a = "Y" OR Ans.a = "N" ) THEN
      retval = True
      ?? Ans.a
      QUITLOOP
   ENDIF
ENDWHILE

IF ( retval = True ) THEN
   return Ans.a
ELSE
   return "Esc"
ENDIF
ENDPROC

PROC PaintCanv.u(Msg)
;
; ** PaintCanv.u = Paint Canvas

@ 1,0 CLEAR EOL
@ 0,0 CLEAR EOL
PAINTCANVAS ATTRIBUTE 112  0, 0, 1, 79
?? Msg
Return
ENDPROC

PROC WpWrite.u(Table_Name, File_Name)
;
;    WpWrite calls the WpWrite Program to write a table out to a WordPerfect
;            Secondary Merge Disk file.
;
;    Inputs:
;            Table_Name = Name of the Table to be written.
;             File_Name = Name of the WordPerfect Secondary Merge File to
;                         be created.

     Private CMD
     Array Tmp_Tables[17]

     Tmp_Tables[1] = "Answer"
     Tmp_Tables[2] = "Changed"
     Tmp_Tables[3] = "Crosstab"
     Tmp_Tables[4] = "Deleted"
     Tmp_Tables[5] = "Entry"
     Tmp_Tables[6] = "Entry1"
     Tmp_Tables[7] = "Entry2"
     Tmp_Tables[8] = "Family"
     Tmp_Tables[9] = "Inserted"
    Tmp_Tables[10] = "Keyviol"
    Tmp_Tables[11] = "Keyviol1"
    Tmp_Tables[12] = "Keyviol2"
    Tmp_Tables[13] = "List"
    Tmp_Tables[14] = "Password"
    Tmp_Tables[15] = "Problems"
    Tmp_Tables[16] = "Password"
    Tmp_Tables[17] = "Struct"

    Table_Found = "N"
    FOR I FROM 1 TO 17
        IF Tmp_Tables[I] = Table_Name THEN
           Table_Found = "Y"
           QUITLOOP
        ENDIF
    ENDFOR

    If Table_Found = "Y" Then
       Rename_Table = "Y"
       Rename "Answer" "Answer2"
       Table_Name2 = "Answer2"
    Else
       Rename_Table = "N"
       Table_Name2 = Table_Name
    Endif
    CMD = "RUN \"WPWRITE " + Table_Name2 + " " + File_Name + "\""
    EXECUTE CMD
    If Rename_Table = "Y" Then
       Rename "Answer2" "Answer"
       Table_Name = "Answer"
    Endif
ENDPROC

WRITELIB "Slash" BldSlash.a, GetYN.a, PaintCanv.u, WpWrite.u, FxWrite.u
